> For the complete documentation index, see [llms.txt](https://docs.namiml.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.namiml.com/sdk-reference/namipurchasemanager/registerrestorepurchaseshandler.md).

# registerRestorePurchasesHandler

{% hint style="info" %}
**Apple Only**

This method is only available from the Nami SDK for Apple devices, or cross-platform SDKs being used on Apple devices.
{% endhint %}

For recommendations on where to present UI elements to your customers during a restore purchases process, see our [Restoring Purchases](doc:restoring-purchases) guide.

{% tabs %}
{% tab title="Swift" %}

```swift
NamiPurchaseManager.registerRestorePurchasesHandler { state, newPurchases, oldPurchases, error in
  // react to restore purchase process
}
```

{% endtab %}

{% tab title="Flutter" %}

```Text
// Coming soon
```

{% endtab %}

{% tab title="React Native" %}

```Text
// Coming soon
```

{% endtab %}

{% tab title="Unity" %}

```Text
NamiPurchaseManager.RegisterRestorePurchasesHandler(restorePurchasesCallback); // Apple only
```

{% endtab %}
{% endtabs %}

**Parameters**

Handler has the following parameters that return data:

* `state` - the [NamiRestorePurchasesState](/sdk-reference/namipurchasemanager/namirestorepurchasesstate.md), on React Native `stateDesc`
* `newPurchases` - a list of new purchases found that will be restored in the Restore Purchases process
* `oldPurchases` - a list of existing purchases already active on the device
* `error` - any error returned by the Restore Purchases process


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.namiml.com/sdk-reference/namipurchasemanager/registerrestorepurchaseshandler.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
